uk.ac.starlink.table

## Class ConcatStarTable

- java.lang.Object
- - uk.ac.starlink.table.WrapperStarTable
  - - uk.ac.starlink.table.ConcatStarTable

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, StarTable

      public class ConcatStarTable
      extends WrapperStarTable

  StarTable implementation which concatenates several tables together top-to-bottom. A (possibly blank) metadata table is supplied to define the column and table metadata for the result, and other data tables are added on one way or another, depending which constructor is used. The columns of each data table must be compatible with the columns of the metadata table, or the the data will not be included.
  Since:
    29 Mar 2004

- - ### Field Summary

    - ### Fields inherited from class uk.ac.starlink.table.WrapperStarTable

      `baseTable`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ConcatStarTable(StarTable meta, java.util.Iterator<StarTable> tableIt)` Constructs a concatenated table from a metadata table and an iterator over data-bearing tables.
    `ConcatStarTable(StarTable meta, StarTable[] tables)` Constructs a concatenated table from a metadata table and an array of data-bearing tables.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ColumnInfo[]` | `extendColumnTypes(ColumnInfo[] colInfos, StarTable[] tables)` Assembles column metadata objects which are compatible between multiple tables.
    `java.lang.Object` | `getCell(long irow, int icol)` Returns the contents of a given table cell.
    `java.lang.Object[]` | `getRow(long irow)` Returns the contents of a given table row.
    `RowAccess` | `getRowAccess()` Returns an object which can provide random access to this table's data, if random access is implemented.
    `long` | `getRowCount()` Returns the number of rows in this table, if known.
    `RowSequence` | `getRowSequence()` Returns an object which can iterate over all the rows in the table sequentially.
    `RowSplittable` | `getRowSplittable()` Returns an object which can iterate over all the rows in the table, but which may also be requested to split recursively for potentially parallel processing.
    `boolean` | `isRandom()` Indicates whether random access is provided by this table.

    - ### Methods inherited from class uk.ac.starlink.table.WrapperStarTable

      `checkedLongToInt, close, getBaseTable, getColumnAuxDataInfos, getColumnCount, getColumnInfo, getName, getParameterByName, getParameters, getURL, setName, setParameter, setURL, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ConcatStarTable

          public ConcatStarTable(StarTable meta,
                                 java.util.Iterator<StarTable> tableIt)

      Constructs a concatenated table from a metadata table and an iterator over data-bearing tables. If any of the tables supplied by the iterator are incompatible with the metadata in `meta` a warning message is issued through the logging system and its rows are ignored.
      Parameters:
        `meta` - table supplying column and table metadata for this one; its row count is ignored and its data is never read
        `tableIt` - iterator over constituent `StarTable`s which taken in sequence supply the row data for this one

    - #### ConcatStarTable

          public ConcatStarTable(StarTable meta,
                                 StarTable[] tables)
                          throws java.io.IOException

      Constructs a concatenated table from a metadata table and an array of data-bearing tables. If any of `tables` are incompatible with the metadata in `meta` an IOException is thrown.
      Parameters:
        `meta` - table supplying column and table metadata for this one; its row count is ignored and its data is never read
        `tables` - array of tables which taken in sequence supply the row data for this one
      Throws:
        `java.io.IOException` - if any of `tables` are not compatible with `meta`

  - ### Method Detail

    - #### getRowCount

          public long getRowCount()

      Description copied from interface: `StarTable`
      Returns the number of rows in this table, if known. If the number of rows cannot be (easily) determined, a value of -1 will be returned.
      Specified by:
        `getRowCount` in interface `StarTable`
      Overrides:
        `getRowCount` in class `WrapperStarTable`
      Returns:
        the number of rows, or -1

    - #### getCell

          public java.lang.Object getCell(long irow,
                                          int icol)
                                   throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns the contents of a given table cell. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`.

      This method is safe for concurrent use from multiple threads, but in general it is recommended to use a `RowAccess` instead.

      Specified by:
        `getCell` in interface `StarTable`
      Overrides:
        `getCell` in class `WrapperStarTable`
      Parameters:
        `irow` - the index of the cell's row
        `icol` - the index of the cell's column
      Returns:
        the contents of this cell
      Throws:
        `java.io.IOException` - if there is an error reading the data

    - #### getRow

          public java.lang.Object[] getRow(long irow)
                                    throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns the contents of a given table row. The returned value is equivalent to an array formed of all the objects returned by `getCell(irow,icol)` for all the columns `icol` in sequence.

      This method is safe for concurrent use from multiple threads, but in general it is recommended to use a `RowAccess` instead.

      Specified by:
        `getRow` in interface `StarTable`
      Overrides:
        `getRow` in class `WrapperStarTable`
      Parameters:
        `irow` - the index of the row to retrieve
      Returns:
        an array of the objects in each cell in row `irow`
      Throws:
        `java.io.IOException` - if there is an error reading the data

    - #### isRandom

          public boolean isRandom()

      Description copied from interface: `StarTable`
      Indicates whether random access is provided by this table. Only if the result is `true` may the `StarTable.getRowAccess()`, `StarTable.getRow(long)` and `StarTable.getCell(long, int)` methods be used.
      Specified by:
        `isRandom` in interface `StarTable`
      Overrides:
        `isRandom` in class `WrapperStarTable`
      Returns:
        `true` if table random access methods are available

    - #### getRowSequence

          public RowSequence getRowSequence()
                                     throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns an object which can iterate over all the rows in the table sequentially. Each such returned object is safe for use within a single thread, but not in general from multiple threads concurrently.
      Specified by:
        `getRowSequence` in interface `StarTable`
      Overrides:
        `getRowSequence` in class `WrapperStarTable`
      Returns:
        new RowSequence
      Throws:
        `java.io.IOException` - if there is an error providing access

    - #### getRowSplittable

          public RowSplittable getRowSplittable()
                                         throws java.io.IOException

      Description copied from interface: `StarTable`
      Returns an object which can iterate over all the rows in the table, but which may also be requested to split recursively for potentially parallel processing.

      The return value must be non-null, and may provide splitting arrangements specially appropriate for the implementation. If this table 'wraps' an upstream table, it is usually best to base the implementation on calls to the the upstream `getRowSplittable` method, so that upstream policy about how to divide up the table is respected. However, implementations without special requirements may return `Tables.getDefaultRowSplittable``(this)`.

      Specified by:
        `getRowSplittable` in interface `StarTable`
      Overrides:
        `getRowSplittable` in class `WrapperStarTable`
      Returns:
        new RowSplittable
      Throws:
        `java.io.IOException`
      See Also:
        `RowRunner`

    - #### getRowAccess

          public RowAccess getRowAccess()

      Description copied from interface: `StarTable`
      Returns an object which can provide random access to this table's data, if random access is implemented. Each such returned object is safe for use within a single thread, but not in general from multiple threads concurrently.
      Specified by:
        `getRowAccess` in interface `StarTable`
      Overrides:
        `getRowAccess` in class `WrapperStarTable`
      Returns:
        new RowAccess

    - #### extendColumnTypes

          public static ColumnInfo[] extendColumnTypes(ColumnInfo[] colInfos,
                                                       StarTable[] tables)
                                                throws java.io.IOException

      Assembles column metadata objects which are compatible between multiple tables. Nullability, array shape and element size are set to values which can accommodate all of the input tables. If column count or column data types are inconsistent, an IOException is thrown.

      This utility method is not used by ConcatStarTable instances, but it may be useful when preparing metadata tables for use with the constructor.

      Parameters:
        `colInfos` - input column metadata objects
        `tables` - list of tables with which columns must be compatible
      Returns:
        new array of new column metadata objects, based on input list
      Throws:
        `java.io.IOException` - if compatibility cannot be achieved